"use strict";

ui.Mappings.ChannelListItems = function(context, listType, isForcedZap, isTvRadio){
    UIMiniFramework.CustomComponents.Context.call(this, context);

    var getServiceListItems = function(){
        return [
            UIMiniFramework.Translations.tv[UIMiniFramework.Globals.language],
            UIMiniFramework.Translations.radio[UIMiniFramework.Globals.language],
            PluginInterface.ServiceZapper.fGetServiceListName(PluginInterface.ServiceZapper.serviceList.FAVORITE_LIST1),
            PluginInterface.ServiceZapper.fGetServiceListName(PluginInterface.ServiceZapper.serviceList.FAVORITE_LIST2),
            PluginInterface.ServiceZapper.fGetServiceListName(PluginInterface.ServiceZapper.serviceList.FAVORITE_LIST3),
            PluginInterface.ServiceZapper.fGetServiceListName(PluginInterface.ServiceZapper.serviceList.FAVORITE_LIST4),
            PluginInterface.ServiceZapper.fGetServiceListName(PluginInterface.ServiceZapper.serviceList.FAVORITE_LIST5)
        ]
    };

    var getServiceListKeys = function(){
        return [
            PluginInterface.ServiceZapper.serviceList.TV_LIST,
            PluginInterface.ServiceZapper.serviceList.RADIO_LIST,
            PluginInterface.ServiceZapper.serviceList.FAVORITE_LIST1,
            PluginInterface.ServiceZapper.serviceList.FAVORITE_LIST2,
            PluginInterface.ServiceZapper.serviceList.FAVORITE_LIST3,
            PluginInterface.ServiceZapper.serviceList.FAVORITE_LIST4,
            PluginInterface.ServiceZapper.serviceList.FAVORITE_LIST5
        ]
    };

    var getServiceListValue = function(){
        return listType == null ? PluginInterface.ServiceZapper.fGetActiveServiceList() : listType;
    };

    this.destroy = function(){
        this.isFiltered = false;
        this.filteredList.length = 0;
    };

    this.setLock = function(isEnabled){
        this.items[1].items[this.items[1].currentItemPositionIndex].isLocked = isEnabled;
        $('.channelListItem.item' + this.items[1].currentItemPositionIndex).toggleClass('lock', isEnabled);
    };

    this.toggleSkip = function () {
        if (this.items[1].totalItems > 0) {
            var serviceList = this.items[0].currentValue;
            var serviceIndex = this.items[1].selectedItemIndex;
            this.items[1].items[this.items[1].currentItemPositionIndex].isSkipped = !this.items[1].items[this.items[1].currentItemPositionIndex].isSkipped;
            PluginInterface.ServiceZapper.fSetSkip(serviceList, serviceIndex, this.items[1].items[this.items[1].currentItemPositionIndex].isSkipped);
            $('.channelListItem.item' + this.items[1].currentItemPositionIndex).toggleClass('skip', this.items[1].items[this.items[1].currentItemPositionIndex].isSkipped);
            // update service list cache
            UIMiniFramework.ServiceListCache.serviceList[serviceList][serviceIndex].isSkipped = this.items[1].items[this.items[1].currentItemPositionIndex].isSkipped;
        }
    };

    this.toggleTvRadio = function () {
        var radioServicesCount = UIMiniFramework.ServiceListCache.serviceListCounts[PluginInterface.ServiceZapper.serviceList.RADIO_LIST];
        var tvServicesCount = UIMiniFramework.ServiceListCache.serviceListCounts[PluginInterface.ServiceZapper.serviceList.TV_LIST];
        switch (this.items[0].currentValue) {
            case PluginInterface.ServiceZapper.serviceList.TV_LIST:
                this.items[0].selectedItemIndex = this.items[0].keys.indexOf(PluginInterface.ServiceZapper.serviceList.RADIO_LIST);
                if (radioServicesCount > 0) {
                    UIMiniFramework.Modules.ZapperWrapper.setActiveService(PluginInterface.ServiceZapper.serviceList.RADIO_LIST, 0, false);
                }
                break;
            default:
                this.items[0].selectedItemIndex = this.items[0].keys.indexOf(PluginInterface.ServiceZapper.serviceList.TV_LIST);
                if (tvServicesCount > 0) {
   UIMiniFramework.Modules.ZapperWrapperApp.ZapperWrapper.setActiveService(PluginInterface.ServiceZapper.serviceList.TV_LIST, 0, false);
                }
                break;
        }
        this.items[0].setSelectedItem();
        this.updateLockStatus();
    };

    this.toggleFav = function () {
        switch (this.items[0].currentValue) {
            case PluginInterface.ServiceZapper.serviceList.FAVORITE_LIST1:
                this.items[0].selectedItemIndex = this.items[0].keys.indexOf(PluginInterface.ServiceZapper.serviceList.FAVORITE_LIST2);
                break;
            case PluginInterface.ServiceZapper.serviceList.FAVORITE_LIST2:
                this.items[0].selectedItemIndex = this.items[0].keys.indexOf(PluginInterface.ServiceZapper.serviceList.FAVORITE_LIST3);
                break;
            case PluginInterface.ServiceZapper.serviceList.FAVORITE_LIST3:
                this.items[0].selectedItemIndex = this.items[0].keys.indexOf(PluginInterface.ServiceZapper.serviceList.FAVORITE_LIST4);
                break;
            case PluginInterface.ServiceZapper.serviceList.FAVORITE_LIST4:
                this.items[0].selectedItemIndex = this.items[0].keys.indexOf(PluginInterface.ServiceZapper.serviceList.FAVORITE_LIST5);
                break;
            default:
                this.items[0].selectedItemIndex = this.items[0].keys.indexOf(PluginInterface.ServiceZapper.serviceList.FAVORITE_LIST1);
                break;
        }
        this.items[0].setSelectedItem();
        this.updateTraversableList(1);
       UIMiniFramework.Modules.ZapperWrapperus();
        ui.App.ZapperWrapper.setActiveService(this.items[0].selectedItemIndex, this.items[1].selectedItemIndex, false);
    };

    this.filterServices = function (value) {
        this.isFiltered = true;
        var listIndex = this.items[0].currentValue;
        this.filteredList = UIMiniFramework.ServiceListCache.serviceList[listIndex].filter(function (element, index, array) {
            element.index = index;
            var item = element.name.toUpperCase().replace(/[ÄÀÁÂ]/g, "A").replace(/[ÜÛÚÙ]/g, "U").replace(/[ÖÕ]/g, "O");
            return item.indexOf(value) > -1;
        });

        var component = this.items[1];
        component.totalItems = this.filteredList.length;
        component.currentItemPositionIndex = 0;
        component.selectedItemIndex = 0;
        var max = component.totalItems > component.totalVisibleItems ? component.totalVisibleItems : component.totalItems;
        component.items.length = 0;
        for (var i = 0; i < max; i++) {
            var serviceIndex = component.totalItems <= component.totalVisibleItems ? i : (component.selectedItemIndex + i) % component.totalItems;
            component.items[i] = PluginInterface.ServiceZapper.fGetServiceExtendedData(listIndex, this.filteredList[i].index);
            component.items[i].realIndex = serviceIndex;
        }
        component.writeItems();
        component.setSelectedItem();
    };

    this.updateLockStatus = function(){
        var lock = this.items[1].totalItems > 0 && this.items[1].items[this.items[1].currentItemPositionIndex].isLocked;
        var label = lock ? UIMiniFramework.Translations.unlock[UIMiniFramework.Globals.language] : UIMiniFramework.Translations.lock[UIMiniFramework.Globals.language];
        this.items[2].setLabel('RED', label);
    };

    this.isFiltered = false;
    this.filteredList = [];
    this.selectedComponentIndex = 1;
    this.template = UIMiniFramework.Templates.simpleWrapper;
    this.items = [
        new UIMiniFramework.CustomComponents.Spinner(
            'serviceList',
            '',
            getServiceListItems(),
            getServiceListKeys(),
            getServiceListValue(),
            function(param){
                this.value = param;
            },
            null,
            null,
            true,
            true,
            function(){
                context.components.updateTraversableList(1);
            }
        ),
        new UIMiniFramework.CustomComponents.TraversableList(
            'services',
            [],
            UIMiniFramework.Templates.channelListItem,
            {
                totalVisibleItems: 7,
                useCounter: false,
                selectWhenNoItems: false
            },
            function(data){
                context.components.isFiltered = false;
                context.components.filteredList.length = 0;
                listType = context.components.items[0].currentValue;
                this.totalItems = PluginInterface.ServiceZapper.fGetNumberOfServices(listType);
                var activeServiceIndex = (UIMiniFramework.Globals.service.activeServiceList != listType) ? 0 : PluginInterface.ServiceZapper.fGetActiveService(listType);
                this.selectedItemIndex = this.totalItems <= this.totalVisibleItems  ? 0 : activeServiceIndex;
                var max = this.totalItems > this.totalVisibleItems ? this.totalVisibleItems : this.totalItems;
                this.items.length = 0;
                for (var i = 0; i < max; i++) {
                    var serviceIndex = this.totalItems <= this.totalVisibleItems ? i : (this.selectedItemIndex + i) % this.totalItems;
                    this.items[i] = PluginInterface.ServiceZapper.fGetServiceExtendedData(listType, serviceIndex);
                    this.items[i].realIndex = serviceIndex;
                }
            },
            function(){
                $('.channelListItem').removeClass('lock skip pay hd uhd');
                $('.channelIndex').text('');
                $('.channelTitle .text').text('');
                $('.channelDescription').text('');
                $('.live, .progressWrapper').addClass('invisible');
                $('.progressValue').removeClass().addClass('progressValue');

                var isActiveService = false;
                var i = this.items.length;
                var doc = document;
                while (i-- > 0) {
                    doc.querySelector('.item' + i + ' .channelIndex').textContent = parseInt(this.items[i].pslIndex, 10);
                    doc.querySelector('.item' + i + ' .channelTitle .text').textContent = this.items[i].name;
                    doc.querySelector('.item' + i + ' .channelDescription').textContent = (this.items[i].event.name) ? this.items[i].event.name : UIMiniFramework.Translations.eventNotAvailable[UIMiniFramework.Globals.language];
                    doc.querySelector('.item' + i + ' .progressWrapper').classList.remove('invisible');
                    doc.querySelector('.item' + i + ' .channelDescription').classList.remove('invisible');
                    doc.querySelector('.item' + i + ' .progressValue').className = 'progressValue progress_' + this.items[i].event.progress;
                    var iconsClassList = (this.items[i].isLocked ? ' lock' : '') + (this.items[i].isSkipped ? ' skip' : '') + (this.items[i].scrambled ? ' pay' : '') + (UIMiniFramework.Tools.isHd(this.items[i].type) ? ' hd' : '') + (UIMiniFramework.Tools.isUhd(this.items[i].type) ? ' uhd' : '');
                    $('.item' + i).addClass(iconsClassList);
                    if (!isActiveService && parseInt(this.items[i].isServiceActive, 10) === 1 && (UIMiniFramework.Globals.service.activeServiceList == context.components.items[0].currentValue)) {
                        doc.querySelector('.item' + i + ' .live').className = 'live';
                        isActiveService = true;
                    }
                }
            },
            function(index){
                index = typeof index == 'undefined' ? this.selectedItemIndex : index;
                index = context.components.isFiltered ? context.components.filteredList[this.selectedItemIndex].index : index;
                var result = PluginInterface.ServiceZapper.fGetServiceExtendedData(listType, index);
                result.realIndex = index;
                return result;
            }
        ),
        new UIMiniFramework.CustomComponents.Button(
            'footer',
            {
                RED: {
                    visible: true,
                    enabled: true,
                    label: UIMiniFramework.Translations.lock[UIMiniFramework.Globals.language]
                },
                GREEN: {
                    visible: true,
                    enabled: true,
                    label: UIMiniFramework.Translations.favourite[UIMiniFramework.Globals.language]
                },
                YELLOW: {
                    visible: true,
                    enabled: true,
                    label: UIMiniFramework.Translations.search[UIMiniFramework.Globals.language]
                },
                BLUE: {
                    visible: true,
                    enabled: true,
                    label: UIMiniFramework.Translations.skip[UIMiniFramework.Globals.language]
                }
            }
        )
    ]
};

UIMiniFramework.Tools.inheritPrototype(ui.Mappings.ChannelListItems, UIMiniFramework.CustomComponents.Context);