"use strict";

ui.Mappings.FavoriteItems = function(context){
    UIMiniFramework.CustomComponents.Context.call(this, context);

    var isFavorite = function (favoriteList) {
        var list = UIMiniFramework.Modules.ChannelList.components.items[0].currentValue;
        var serviceIndex = UIMiniFramework.Modules.ChannelList.components.items[1].items[UIMiniFramework.Modules.ChannelList.components.items[1].currentItemPositionIndex].realIndex;
        var lcn = UIMiniFramework.ServiceListCache.serviceListLcn[list][serviceIndex];

        // check if lcn exist in fav list
        //var favoriteServiceIndex = UIMiniFramework.ServiceListCache.serviceListLcn[favoriteList].indexOf(lcn);
        var favoriteServiceIndexes = UIMiniFramework.Tools.allArrayIndexOf(UIMiniFramework.ServiceListCache.serviceListLcn[favoriteList], lcn);
        var count = favoriteServiceIndexes.length;
        var isFavoriteSet = false;
        for (var j = 0; j < count; j++) {
            if (isFavoriteSet) {
                continue;
            }
            var favoriteServiceIndex = favoriteServiceIndexes[j];
            // get favorite service data
            var favoriteService = UIMiniFramework.ServiceListCache.serviceList[favoriteList][favoriteServiceIndex];
            var favoriteServiceType = parseInt(favoriteService.type, 10);
            switch (list) {
                case PluginInterface.ServiceZapper.serviceList.TV_LIST:
                    isFavoriteSet = PluginInterface.ServiceZapper.tvServiceTypes.indexOf(favoriteServiceType) >= 0;
                    break;
                case PluginInterface.ServiceZapper.serviceList.RADIO_LIST:
                    isFavoriteSet = PluginInterface.ServiceZapper.radioServiceTypes.indexOf(favoriteServiceType) >= 0;
                    break;
                default:
                    isFavoriteSet = true;
                    break;
            }
        }
        return isFavoriteSet;
    };

    var onCLick = function (isFavorite, destinationList) {
        var sourceList = UIMiniFramework.Modules.ChannelList.components.items[0].currentValue;
        var serviceIndex = UIMiniFramework.Modules.ChannelList.components.items[1].items[UIMiniFramework.Modules.ChannelList.components.items[1].currentItemPositionIndex].realIndex;

        if (isFavorite) {
            PluginInterface.ServiceZapper.fAddFavorite(destinationList, sourceList, serviceIndex);
        }
        else {
            PluginInterface.ServiceZapper.fDelFavorite(destinationList, sourceList, serviceIndex);
            if (sourceList == destinationList) {
                context.destroy();
                UIMiniFramework.Modules.ChannelList.components.updateTraversableList(1);
                if (UIMiniFramework.Modules.ChannelList.components.items[1].totalItems === 0) {
                    UIMiniFramework.Modules.ChannelList.destroy();
                    UIMiniFramework.Modules.ChannelList.create(PluginInterface.ServiceZapper.serviceList.TV_LIST, true);
                    UIMiniFramework.Modules.ChannelList.show();
                    UIMiniFramework.Modules.ZapperWrapper.setActiveService(PluginInterface.ServiceZapper.serviceList.TV_LIST, 0);
                }
            }
        }
        // update service list cach
        UIMiniFramework.ServiceListCache.update(destinationList);
    };

    this.destroy = function(){
        UIMiniFramework.Modules.ChannelList.toggleDescriptionAndProgress(true);
    };

    this.template = UIMiniFramework.Templates.simpleWrapper;
    this.items = [
        new UIMiniFramework.CustomComponents.RadioButton(
            'favorite',
            [
                {
                    class: '',
                    value: isFavorite(PluginInterface.ServiceZapper.serviceList.FAVORITE_LIST1),
                    onClick: function(value){
                        onCLick(value, PluginInterface.ServiceZapper.serviceList.FAVORITE_LIST1)
                    }
                },
                {
                    class: '',
                    value: isFavorite(PluginInterface.ServiceZapper.serviceList.FAVORITE_LIST2),
                    onClick: function(value){
                        onCLick(value, PluginInterface.ServiceZapper.serviceList.FAVORITE_LIST2)
                    }
                },
                {
                    class: '',
                    value: isFavorite(PluginInterface.ServiceZapper.serviceList.FAVORITE_LIST3),
                    onClick: function(value){
                        onCLick(value, PluginInterface.ServiceZapper.serviceList.FAVORITE_LIST3)
                    }
                },
                {
                    class: '',
                    value: isFavorite(PluginInterface.ServiceZapper.serviceList.FAVORITE_LIST4),
                    onClick: function(value){
                        onCLick(value, PluginInterface.ServiceZapper.serviceList.FAVORITE_LIST4)
                    }
                },
                {
                    class: '',
                    value: isFavorite(PluginInterface.ServiceZapper.serviceList.FAVORITE_LIST5),
                    onClick: function(value){
                        onCLick(value, PluginInterface.ServiceZapper.serviceList.FAVORITE_LIST5)
                    }
                }
            ]
        )
    ]
};

UIMiniFramework.Tools.inheritPrototype(ui.Mappings.FavoriteItems, UIMiniFramework.CustomComponents.Context);