"use strict";

ui.Mappings.PinItems = function(context){
    UIMiniFramework.CustomComponents.Context.call(this, context);

    var validatePin = function(){
        var pin = this.items.join('');
        if (!UIMiniFramework.Tools.isStbPinCodeValid(pin, false)) {
            this.resetPins();
            return false;
        }
        //toggle lock, set service, change lock indicator, update local items
        switch (context.caller){
            case UIMiniFramework.Modules.Settings:
                var componentsMap = context.caller.screens.channelListEditor.getComponentMap();
                var serviceList = context.caller.components.items[componentsMap.connectionComponentIndex].items[context.caller.components.items[componentsMap.connectionComponentIndex].selectedItemIndex].value;
                var serviceIndex = context.caller.components.items[componentsMap.componentIndex].selectedItemIndex;
                var lock = !PluginInterface.ParentalControl.fGetServiceLock(serviceList, serviceIndex);
                PluginInterface.ParentalControl.fSetServiceLock(serviceList, serviceIndex, lock);
                context.caller.components.setLock(lock, componentsMap.componentIndex);
                context.caller.screens.channelListEditor.refreshList(componentsMap.componentIndex);
                break;
            case UIMiniFramework.Modules.ChannelList:
                var serviceList = UIMiniFramework.Modules.ChannelList.components.items[0].currentValue;
                var serviceIndex = UIMiniFramework.Modules.ChannelList.components.items[1].items[UIMiniFramework.Modules.ChannelList.components.items[1].currentItemPositionIndex].realIndex;
                var lock = !PluginInterface.ParentalControl.fGetServiceLock(serviceList, serviceIndex);
                PluginInterface.ParentalControl.fSetServiceLock(serviceList, serviceIndex, lock);
                UIMiniFramework.Modules.ChannelList.components.setLock(lock);
                if (serviceIndex == UIMiniFramework.Globals.service.activeChannelIndex) {
                    UIMiniFramework.Globals.service.isServiceLocked = parseInt(lock, 10) == 1 ? true : false;
                    if (UIMiniFramework.Modules.PinEntry.isCreated && !UIMiniFramework.Globals.service.isServiceLocked) {
                        UIMiniFramework.Modules.PinEntry.destroy(PluginInterface.ParentalControl.eLockType.CHANNEL);
                    }
                }
                break;
        }
        context.destroy();
    };

    this.destroy = function(){
        switch (context.caller){
            case UIMiniFramework.Modules.Settings:
                context.caller.screens.channelListEditor.toggleDescription(true);
                break;
            case UIMiniFramework.Modules.ChannelList:
                context.caller.components.updateLockStatus();
                context.caller.toggleDescriptionAndProgress(true);
                break;
        }
    };

    this.template = UIMiniFramework.Templates.simpleWrapper;
    this.items = [
        new UIMiniFramework.CustomComponents.Password(
            'pin',
            UIMiniFramework.Translations.enterPin[UIMiniFramework.Globals.language] + ':',
            function(param){},
            true,
            true,
            4,
            validatePin
        )
    ]
};

UIMiniFramework.Tools.inheritPrototype(ui.Mappings.PinItems, UIMiniFramework.CustomComponents.Context);