"use strict";

ui.Mappings.CustomPermanentInformations = {

    toggleExternalComponents: function(isCreated){
        if (UIMiniFramework.Config.MODULES.LanguageSubtitle) {
            UIMiniFramework.Modules.LanguageSubtitle.toggleSubtitle();
        }
    },
    // removed only by signal regained callback
    standbyNspd: {
        timerId: null,
        timerCount: 60,

        create: function (messageCode) {
            $('.permanentInformation.' + messageCode + ' .noSignalTimer').text(--ui.Mappings.CustomPermanentInformations.standbyNspd.timerCount + ' ' + UIMiniFramework.Translations.seconds[UIMiniFramework.Globals.language]);
            clearTimeout(this.timerId);
            this.timerId = setInterval(function () {
                $('.permanentInformation.' + messageCode + ' .noSignalTimer').text(--ui.Mappings.CustomPermanentInformations.standbyNspd.timerCount + ' ' + UIMiniFramework.Translations.seconds[UIMiniFramework.Globals.language]);
                if (ui.Mappings.CustomPermanentInformations.standbyNspd.timerCount == 0) {
                    clearInterval(ui.Mappings.CustomPermanentInformations.standbyNspd.timerId);
                    UIMiniFramework.Modules.PermanentInformations.removeByCode('standbyNspd');
                }
            }, 1000);
        },

        destroy: function (messageCode) {
            clearInterval(this.timerId);
            this.timerCount = 60;
        },

        keyPressed: function () {
        },

        handleKeyPress: function (keyCode) {
            switch (keyCode) {
                default:
                    this.keyPressed();
                    return false;
            }
        }
    },

    // removed only by settings menu - sleep timer OFF
    standbySleep: {
        timerId: null,
        timerCount: 60,

        create: function (messageCode) {
            $('.permanentInformation.' + messageCode + ' .sleepTimer').text(--ui.Mappings.CustomPermanentInformations.standbySleep.timerCount + ' ' + UIMiniFramework.Translations.seconds[UIMiniFramework.Globals.language]);
            clearTimeout(this.timerId);
            this.timerId = setInterval(function () {
                $('.permanentInformation.' + messageCode + ' .sleepTimer').text(--ui.Mappings.CustomPermanentInformations.standbySleep.timerCount + ' ' + UIMiniFramework.Translations.seconds[UIMiniFramework.Globals.language]);
                if (ui.Mappings.CustomPermanentInformations.standbySleep.timerCount == 0) {
                    clearInterval(ui.Mappings.CustomPermanentInformations.standbySleep.timerId);
                    UIMiniFramework.Modules.PermanentInformations.removeByCode('standbySleep');
                }
            }, 1000);
        },

        destroy: function (messageCode) {
            clearInterval(this.timerId);
            this.timerCount = 60;
        },

        keyPressed: function () {
        },

        handleKeyPress: function (keyCode) {
            switch (keyCode) {
                default:
                    this.keyPressed();
                    return false;
            }
        }
    },

    closableEntitlementMessage: {
        isCreated: false,
        create: function (messageCode) {
            this.isCreated = true;
            UIMiniFramework.Modules.PinEntry.destroy(-1, true);
        },

        destroy: function (messageCode) {
            this.isCreated = false;
            UIMiniFramework.Modules.PinEntry.toggle();
        },

        keyPressed: function () {
            UIMiniFramework.Modules.PermanentInformations.removeByCode('closableEntitlementMessage');
            ui.App.Callbacks.confirmEntitlementMessage();
        },

        handleKeyPress: function (keyCode) {
            switch (keyCode) {
                case UIMiniFramework.Keys.OK:
                case UIMiniFramework.Keys.Exit:
                case UIMiniFramework.Keys.Back:
                    this.keyPressed();
                    return true;
                default:
                    return false;
            }
        }
    },

    smartCardExtracted: {
        isCreated: false,
        create: function (messageCode) {
            this.isCreated = true;
            UIMiniFramework.Modules.PinEntry.toggle();
        },

        destroy: function (messageCode) {
            this.isCreated = false;
            UIMiniFramework.Modules.PinEntry.toggle();
        },

        keyPressed: function () {
        },

        handleKeyPress: function (keyCode) {
            switch (keyCode) {
                default:
                    return false;
            }
        }
    },

    smartCardCode: {
        isCreated: false,
        create: function (messageCode) {
            this.isCreated = true;
            UIMiniFramework.Modules.PinEntry.toggle();
        },

        destroy: function (messageCode) {
            this.isCreated = false;
            UIMiniFramework.Modules.PinEntry.toggle();
        },

        keyPressed: function () {
        },

        handleKeyPress: function (keyCode) {
            switch (keyCode) {
                default:
                    return false;
            }
        }
    }
};