"use strict";

UIMiniFramework.CustomComponents.Progress = function(className, label, value, saveHandler, selectable, useProgressValues){
    UIMiniFramework.CustomComponents.GenericComponent.call(this);
    var items = Array.apply(null, {length: 101}).map(Number.call, Number);
    this.class = className;
    this.selectable = typeof selectable == 'undefined' ? true : selectable;
    this.useProgressValues = typeof useProgressValues == 'undefined' ? true : useProgressValues;
    this.type = UIMiniFramework.Globals.componentTypes.progress;
    this.template = UIMiniFramework.Templates.progressComponent;
    this.label = label;
    this.items = items;
    this.keys = items;
    this.value = value;
    this.selectedItemIndex = items.indexOf(value);
    this.save = typeof saveHandler == 'function' ? saveHandler : function(){};
};

UIMiniFramework.Tools.inheritPrototype(UIMiniFramework.CustomComponents.Progress, UIMiniFramework.CustomComponents.GenericComponent);

UIMiniFramework.CustomComponents.Progress.prototype.renderSpecificComponent = function(component){
    if (!this.useProgressValues){
        component.find('.progressValueWrapper').remove();
    }
};

UIMiniFramework.CustomComponents.Progress.prototype.setSelectedItem = function(){
    if (this.useProgressValues) {
        $('.' + this.code).find('.item').text(this.items[this.selectedItemIndex]);
    }
    $('.' + this.code).find('.progress').css('width', this.items[this.selectedItemIndex] + '%');
};

UIMiniFramework.CustomComponents.Progress.prototype.updateProgressBar = function(value){
    if (this.useProgressValues) {
        $('.' + this.code).find('.item').text(value);
    }
    $('.' + this.code).find('.progress').css('width', value + '%');
};

UIMiniFramework.CustomComponents.Progress.prototype.updateLabels = function(){
    $('.' + this.code).children('.label').text(this.label);
    if (this.useProgressValues) {
        $('.' + this.code).find('.item').text(this.items[this.selectedItemIndex]);
    }
    $('.' + this.code).find('.progress').css('width', this.items[this.selectedItemIndex] + '%');
};
UIMiniFramework.CustomComponents.Progress.prototype.setSelectedItemIndex = function(direction){
    var size = this.items.length;
    if (this.selectedItemIndex + direction > size - 1 || this.selectedItemIndex + direction < 0) {
        return;
    }
    if (this.selectedItemIndex + direction > size - 1){
        this.selectedItemIndex = 0;
    }
    else if (this.selectedItemIndex + direction < 0) {
        this.selectedItemIndex = size - 1;
    }
    else {
        this.selectedItemIndex += direction;
    }
};
