"use strict";

UIMiniFramework.Modules.DummyVideoController = {
    el: null,
    volume: 0.5,
    videoStreamPath: 'http://tt30adk.iwedia.com/demoapp/video',
    audioStreamPath: 'http://tt30adk.iwedia.com/demoapp/audio',

    init: function () {
        this.el = document.getElementById("liveVideo");
    },

    play: function () {
        if (UIMiniFramework.Config.isDummyVideoControllerEnabled && this.el) {
            this.el.play();
        }
    },

    pause: function () {
        if (this.el) {
            this.el.pause();
        }
    },

    stop: function () {
        if (this.el) {
            this.el.pause();
            this.el.currentTime = 0;
        }
    },

    restart: function () {
        if (this.el) {
            this.el.currentTime = 0;
        }
    },

    skip: function (value) {
        if (this.el) {
            this.el.currentTime += value;
        }
    },

    setVideo: function (fileURL) {
        if (this.el) {
            if (fileURL != "") {
                this.el.src = fileURL;
                this.play();
            } else {
                console.log("Enter a valid video URL");
            }
        }
    },

    setVolume: function (value) {
        if (this.el) {
            this.volume = value;
            this.el.volume = value;
        }
    },

    setMute: function (value) {
        if (this.el) {
            this.el.muted = value == 1 ? true : false;
        }
    }
};