'use strict';

UIMiniFramework.Modules.ZapperWrapper = {
    setActiveService: function (list, index, showInfoBanner) {
        UIMiniFramework.Modules.ZapperWrapper.preZappFunction();
        showInfoBanner = typeof showInfoBanner == 'undefined' ? true : showInfoBanner;
        if (showInfoBanner) {
            if (UIMiniFramework.Config.MODULES.InfoBanner && !UIMiniFramework.Modules.InfoBanner.isCreated) {
                UIMiniFramework.Modules.InfoBanner.create(0, index, list);
            }
        }
        setTimeout(function () {
            PluginInterface.ServiceZapper.fSetActiveService(list, index);
        }, 50);
    },

    setNextService: function () {
        if (UIMiniFramework.Globals.service.isZapOnDigitInProgress) {
            return false;
        }
        if (UIMiniFramework.Config.MODULES.Pvr && UIMiniFramework.Modules.Pvr.isCurrentlyRecording) {
            UIMiniFramework.Modules.Pvr.shiftChannel();
            PluginInterface.ServiceZapper.fSetNextActiveService();
            return;
        }
        UIMiniFramework.Modules.ZapperWrapper.preZappFunction();
        if (UIMiniFramework.Config.MODULES.InfoBanner) {
            var isCreated = UIMiniFramework.Modules.InfoBanner.isCreated;
            UIMiniFramework.Modules.InfoBanner.create(1, -1, -1, false, isCreated);
        }
        setTimeout(function () {
            PluginInterface.ServiceZapper.fSetNextActiveService();
        }, 50);
    },

    setPreviousService: function () {
        if (UIMiniFramework.Globals.service.isZapOnDigitInProgress) {
            return false;
        }
        if (UIMiniFramework.Config.MODULES.Pvr && UIMiniFramework.Modules.Pvr.isCurrentlyRecording) {
            UIMiniFramework.Modules.Pvr.shiftChannel();
            PluginInterface.ServiceZapper.fSetPreviousActiveService();
            return;
        }
        UIMiniFramework.Modules.ZapperWrapper.preZappFunction();
        if (UIMiniFramework.Config.MODULES.InfoBanner) {
            var isCreated = UIMiniFramework.Modules.InfoBanner.isCreated;
            UIMiniFramework.Modules.InfoBanner.create(-1, -1, -1, false, isCreated);
        }
        setTimeout(function () {
            PluginInterface.ServiceZapper.fSetPreviousActiveService();
        }, 50);
    },

    setLastPlayedService: function (showInfoBanner) {
        showInfoBanner = typeof showInfoBanner == 'undefined' ? false : showInfoBanner;
        UIMiniFramework.Modules.ZapperWrapper.preZappFunction();
        if (showInfoBanner) {
            var lastServiceList = PluginInterface.ServiceZapper.getLastActiveServiceList();
            var lastServiceIndex = PluginInterface.ServiceZapper.fGetLastPlayedService();
            if (UIMiniFramework.Config.MODULES.InfoBanner) {
                UIMiniFramework.Modules.InfoBanner.create(0, lastServiceIndex, lastServiceList);
            }
        }
        setTimeout(function () {
            PluginInterface.ServiceZapper.fPlayLastService();
        }, 120);
    },

    setServiceOnDigit: function (digit) {
        if (UIMiniFramework.Config.MODULES.Pvr && UIMiniFramework.Modules.Pvr.isCurrentlyRecording) {
            UIMiniFramework.Modules.Pvr.shiftChannel(true);
            PluginInterface.ServiceZapper.fZappOnDigit(digit);
            return;
        }
        UIMiniFramework.Modules.ZapperWrapper.preZappFunction();
        PluginInterface.ServiceZapper.fZappOnDigit(digit);
    },

    swapLastServices: function () {
        if (UIMiniFramework.Globals.service.isZapOnDigitInProgress) {
            return false;
        }
        if (UIMiniFramework.Config.MODULES.Pvr && UIMiniFramework.Modules.Pvr.isCurrentlyRecording) {
            UIMiniFramework.Modules.Pvr.shiftChannel();
            PluginInterface.ServiceZapper.fSwapLastChannels();
            return;
        }
        UIMiniFramework.Modules.ZapperWrapper.preZappFunction();
        PluginInterface.ServiceZapper.fSwapLastChannels();
    },

    stopActiveService: function(){
        UIMiniFramework.Globals.service.isZapped = false;
        UIMiniFramework.Globals.service.isActiveServiceStopped = true;
        PluginInterface.ServiceZapper.fStopActiveService();
        if (UIMiniFramework.Config.MODULES.RadioPlayingOverlay) {
            UIMiniFramework.Modules.RadioPlayingOverlay.destroy();
        }
        UIMiniFramework.Modules.DummyVideoController.stop();
    },

    preZappFunction: function () {
        // reset service locked status
        UIMiniFramework.Globals.service.isServiceLocked = false;
        UIMiniFramework.Globals.service.isServiceAgeLocked = false;
        UIMiniFramework.Globals.service.actuallServiceList = null;
        UIMiniFramework.Globals.service.isZapped = false;
        if (UIMiniFramework.Config.MODULES.RadioPlayingOverlay) {
            UIMiniFramework.Modules.RadioPlayingOverlay.destroy();
        }
        // destroy pin entry popup
        if (UIMiniFramework.Config.MODULES.PinEntry) {
            UIMiniFramework.Modules.PinEntry.destroy(-1, true);
        }
        UIMiniFramework.Modules.PermanentInformations.removeByCode('smartCardCode');
        UIMiniFramework.Modules.PermanentInformations.removeByCode('serviceConnectCode');
        UIMiniFramework.Modules.PermanentInformations.removeByCode('entitlementMessage');
        UIMiniFramework.Modules.PermanentInformations.removeByCode('closableEntitlementMessage');
        UIMiniFramework.Modules.PermanentInformations.removeByCode('signalStatusCode');
        UIMiniFramework.Modules.PermanentInformations.removeByCode('scNotActivated');
        UIMiniFramework.Modules.PermanentInformations.removeByCode('scIdMismatch');
    }
};